<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑我的水票' : '添加我的水票'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="模板ID" name="templateId">
        <a-input
          allow-clear
          placeholder="请输入模板ID"
          v-model:value="form.templateId"
        />
      </a-form-item>
      <a-form-item label="商品ID" name="goodsId">
        <a-input
          allow-clear
          placeholder="请输入商品ID"
          v-model:value="form.goodsId"
        />
      </a-form-item>
      <a-form-item label="订单ID" name="orderId">
        <a-input
          allow-clear
          placeholder="请输入订单ID"
          v-model:value="form.orderId"
        />
      </a-form-item>
      <a-form-item label="订单编号" name="orderNo">
        <a-input
          allow-clear
          placeholder="请输入订单编号"
          v-model:value="form.orderNo"
        />
      </a-form-item>
      <a-form-item label="订单商品ID" name="orderGoodsId">
        <a-input
          allow-clear
          placeholder="请输入订单商品ID"
          v-model:value="form.orderGoodsId"
        />
      </a-form-item>
      <a-form-item label="总数量" name="totalQty">
        <a-input
          allow-clear
          placeholder="请输入总数量"
          v-model:value="form.totalQty"
        />
      </a-form-item>
      <a-form-item label="可用数量" name="availableQty">
        <a-input
          allow-clear
          placeholder="请输入可用数量"
          v-model:value="form.availableQty"
        />
      </a-form-item>
      <a-form-item label="冻结数量" name="frozenQty">
        <a-input
          allow-clear
          placeholder="请输入冻结数量"
          v-model:value="form.frozenQty"
        />
      </a-form-item>
      <a-form-item label="已使用数量" name="usedQty">
        <a-input
          allow-clear
          placeholder="请输入已使用数量"
          v-model:value="form.usedQty"
        />
      </a-form-item>
      <a-form-item label="已释放数量" name="releasedQty">
        <a-input
          allow-clear
          placeholder="请输入已释放数量"
          v-model:value="form.releasedQty"
        />
      </a-form-item>
      <a-form-item label="备注" name="comments">
        <a-textarea
          :rows="4"
          :maxlength="200"
          placeholder="请输入描述"
          v-model:value="form.comments"
        />
      </a-form-item>
<!--      <a-form-item label="状态" name="status">-->
<!--        <a-radio-group v-model:value="form.status">-->
<!--          <a-radio :value="0">显示</a-radio>-->
<!--          <a-radio :value="1">隐藏</a-radio>-->
<!--        </a-radio-group>-->
<!--      </a-form-item>-->
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addGltUserTicket, updateGltUserTicket } from '@/api/glt/gltUserTicket';
  import { GltUserTicket } from '@/api/glt/gltUserTicket/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: GltUserTicket | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<GltUserTicket>({
    id: undefined,
    templateId: undefined,
    goodsId: undefined,
    orderId: undefined,
    orderNo: undefined,
    orderGoodsId: undefined,
    totalQty: undefined,
    availableQty: undefined,
    frozenQty: undefined,
    usedQty: undefined,
    releasedQty: undefined,
    userId: undefined,
    sortNumber: undefined,
    comments: undefined,
    status: undefined,
    deleted: undefined,
    tenantId: undefined,
    createTime: undefined,
    updateTime: undefined,
    gltUserTicketId: undefined,
    gltUserTicketName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    gltUserTicketName: [
      {
        required: true,
        type: 'string',
        message: '请填写我的水票名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateGltUserTicket : addGltUserTicket;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
